
#include "Deplacement.h"

Deplacement::Deplacement():position(5.0f, 5.0f, 5.0f),
							g_vLook(-0.5f, -0.5f, -0.5f),
							g_vUp(0.0f, 1.0f, 0.0f),
							g_vRight(1.0f, 0.0f, 0.0f){
	POINT lpPoint;
	if (!GetCursorPos(&lpPoint)){
		MessageBox(fenetre::hWnd,"Impossible de recuperer la position de la souris...","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		exit(-1);
	};
	fenetre::initSouris(&lpPoint);
	g_fMoveSpeed=100;
};

Deplacement::Deplacement(vecteur3f pos):position(pos),
							g_vLook(-0.5f, -0.5f, -0.5f),
							g_vUp(0.0f, 1.0f, 0.0f),
							g_vRight(1.0f, 0.0f, 0.0f){
	POINT lpPoint;
	if (!GetCursorPos(&lpPoint)){
		MessageBox(fenetre::hWnd,"Impossible de recuperer la position de la souris...","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		exit(-1);
	};
	fenetre::initSouris(&lpPoint);
	g_fMoveSpeed=100;
};

Deplacement::Deplacement(GLfloat x,GLfloat y,GLfloat z):position(x,y,z),
							g_vLook(-0.5f, -0.5f, -0.5f),
							g_vUp(0.0f, 1.0f, 0.0f),
							g_vRight(1.0f, 0.0f, 0.0f){
	POINT lpPoint;
	if (!GetCursorPos(&lpPoint)){
		MessageBox(fenetre::hWnd,"Impossible de recuperer la position de la souris...","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		exit(-1);
	};
	fenetre::initSouris(&lpPoint);
	g_fMoveSpeed=100;
};

void Deplacement::actualise(){
	matrix4x4f matRotation;
	if(fenetre::keys[259]){			//bouton souris droit
		if (fenetre::sourisdx!=0){
			vecteur3f haut(0.0f, 1.0f, 0.0f);
            matRotation.rotate( (float)fenetre::sourisdx / 5.0f, haut);
            matRotation.transformVector( &g_vLook );
            matRotation.transformVector( &g_vUp );
		};
		if (fenetre::sourisdy!=0){
			matRotation.rotate( (float)fenetre::sourisdy / 5.0f, g_vRight );
            matRotation.transformVector( &g_vLook );
            matRotation.transformVector( &g_vUp );
		};
	};
	if(fenetre::keys[257]){			//bouton souris gauche
		HMENU hMenu;
		POINT pt;
		GetCursorPos(&pt);
		hMenu=CreatePopupMenu();
		AppendMenu(hMenu,MF_STRING,1,"Charger fichier              \t(C)");
		AppendMenu(hMenu,MF_STRING,2,"Dcharger fichier            \t(D)");
		TrackPopupMenu(hMenu,NULL,pt.x,pt.y,0,fenetre::hWnd,NULL);
		fenetre::keys[257]=false;
	};
	vecteur3f tmpLook  = g_vLook;
	vecteur3f tmpRight = g_vRight;
	if (fenetre::keys[VK_UP]){
		position -= tmpLook*-g_fMoveSpeed*fenetre::temps;
	};
	if (fenetre::keys[VK_DOWN]){
		position += (tmpLook*-g_fMoveSpeed)*fenetre::temps;
	};
	if (fenetre::keys[VK_LEFT]){
		position -= (tmpRight*g_fMoveSpeed)*fenetre::temps;
	};
	if (fenetre::keys[VK_RIGHT]){
		position += (tmpRight*g_fMoveSpeed)*fenetre::temps;
	};
	if (fenetre::keys['C']){
		PostMessage(fenetre::hWnd,WM_COMMAND,1,0);
		fenetre::keys['C']=false;
	};
	if (fenetre::keys['D']){
		PostMessage(fenetre::hWnd,WM_COMMAND,2,0);
		fenetre::keys['D']=false;
	};
	fenetre::sourisdy=0;
	fenetre::sourisdx=0;
};


void Deplacement::updateViewMatrix(){
	matrix4x4f view;

	g_vLook.normaliz();

	g_vRight = crossProduct(g_vLook, g_vUp);
	g_vRight.normaliz();

	g_vUp = crossProduct(g_vRight, g_vLook);
	g_vUp.normaliz();

	view.m[0] =  g_vRight.x;
	view.m[1] =  g_vUp.x;
	view.m[2] = -g_vLook.x;
	view.m[3] =  0.0f;

	view.m[4] =  g_vRight.y;
	view.m[5] =  g_vUp.y;
	view.m[6] = -g_vLook.y;
	view.m[7] =  0.0f;

	view.m[8]  =  g_vRight.z;
	view.m[9]  =  g_vUp.z;
	view.m[10] = -g_vLook.z;
	view.m[11] =  0.0f;

	view.m[12] = -dotProduct(g_vRight, position);
	view.m[13] = -dotProduct(g_vUp, position);
	view.m[14] =  dotProduct(g_vLook, position);
	view.m[15] =  1.0f;

	glMultMatrixf( view.m );
};
